package fr.username404.snowygui.forge

import fr.username404.snowygui.Snowy
import fr.username404.snowygui.config.SnowyConfigScreen
import fr.username404.snowygui.config.configScreenParent
import fr.username404.snowygui.gui.feature.ButtonImpl
import net.neoforged.fml.ModContainer
import net.neoforged.fml.ModList
import net.neoforged.fml.common.Mod
import net.neoforged.fml.event.lifecycle.FMLClientSetupEvent
import net.neoforged.neoforge.client.gui.IConfigScreenFactory
import net.neoforged.neoforge.common.NeoForge
import net.neoforged.neoforgespi.language.ModFileScanData
import org.objectweb.asm.Type

@Mod("snowygui")
@Suppress("UNUSED_PARAMETER")
class ForgeInit(container: ModContainer): Snowy() {
    private fun initSetup(event: FMLClientSetupEvent) = atInit()
    override val annotatedButtons = ModList.get() // Forge-specific reflection
        .allScanData
        .flatMap { obj: ModFileScanData -> obj.classes }
        .filter { data: ModFileScanData.ClassData? ->
            (data!!.javaClass.getDeclaredField("clazz").apply { isAccessible = true }.get(data) as Type).className.let { classname ->
                classname.startsWith(FeaturePackage) && Class.forName(classname).isValidForButtonCollection()
            }
        }
        .map { Class.forName((it!!.javaClass.getDeclaredField("clazz").apply { isAccessible = true }.get(it) as Type).className).asSubclass(ButtonImpl::class.java)}
        .toSet()
    init {
        NeoForge.EVENT_BUS.run {
            addListener(this@ForgeInit::initSetup)
            register(EndTickHandler)
            register(MiscHandlers)
            register(HudHandler)
            register(ZoomHandler)
        }
        container.registerExtensionPoint(
            IConfigScreenFactory::class.java,
            IConfigScreenFactory { _, parent -> configScreenParent = parent; SnowyConfigScreen }
        )
    }
}